/*
 * ASE1701.asm
 *
 *  Created: 18/01/2017 18.16.21
 *  Author: Roberto Roncella
 *  Compito del 13/01/2017
 *  Realizzare una subroutine per il microcontrollore AVR XMEGA256A3BU, 
 *  che lascia in R16 il valore di X modulo 10. 
 *  Determinarne il tempo massimo di esecuzione. 
 *  Individuare se possibile una soluzione che, per qualsiasi valore di X, 
 *  completa il compito con un numero di cicli inferiore a 100.
 */ 
main:
 nop //per caricare la pipeline
 rcall mod10 //da usare con le funzioni del debugger
 rcall mod10speed
 rjmp main

/*
 *  La soluzione seguente, proposta e testata nello scorso compito, funziona correttamente
 *  ma sicuramente richiede tempi di esecuzione inaccettabili. Infatti il massimo numero di 
 *  iterazioni si ottiene con valori di X prossimi al massimo (>=65530). Per questi valori,
 *  il tempo di esecuzione (compresa la rcall e la ret) vale 26232 T.
 */
 mod10:
 push XH
 push XL
 m1:
  sbiw XH:XL,10
  brcc m1
 adiw XH:XL,10
 mov R16,XL
 pop XL
 pop XH
 ret

/*
 *  Questa nuova soluzione, piu` articolata, sfrutta le proprieta` del modulo
 *  per ottenere un risparmio in tempo di esecuzione, ottenendo il risultato con 24 istruzioni. 
 *  Evitando l'uso di loop dal numero di iterazioni dipendenti dal dato, il
 *  tempo di elecuzione non cambia coi dati e vale 31 T (compresa rcall e ret),
 *  soddisfacendo i requisiti assegnati.
 */
 mod10speed:
 mov R16,XH
 sbrc R16,7 //testa il bit 7 di XH, e se uno riduce togliendo 120
 subi R16,120 // al massimo ora R16 vale 135 (255 - 120)
 sbrc R16,0 //testa il bit 0 di XH, che pesa 6 (256 mod 10)
 subi R16,-5 //se non nullo, somma 5 (+1 presente) e non ci puo` essere carry
 add R16,XL //ora aggiunge la parte bassa e ci puo` essere carry (255 + 140)
 brcc lp01
 subi R16,-6 //ogni carry vale 6 sul risultato; ora non ci puo` essere carry (139 + 6)
 lp01: subi R16,160 //si parte confrontando con 160, poi si dimezza a ogni stadio
 brcc lp02
 subi R16,-160
 lp02: subi R16,80
 brcc lp03
 subi R16,-80
 lp03: subi r16,40
 brcc lp04
 subi R16,-40
 lp04: subi r16,20
 brcc lp05
 subi R16,-20
 lp05: subi r16,10
 brcc lp06
 subi R16,-10
 lp06: ret //ora sicuramente siamo tra 0 e 9